> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List of accounts

> Returns a list of blockchain accounts with their current balance.<br/> For rebasing assets, the balances returned are adjusted according to the current rebasing conditions.<br/> Results are ordered by tuple `(creation_chain_sequence_number, account)`.<br/> To fetch the next page of results use `next_page_url` JSON response field.



## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /blockchain-v2/{asset}/accounts
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /blockchain-v2/{asset}/accounts:
    servers:
      - url: https://api.coinmetrics.io/v4
      - url: https://community-api.coinmetrics.io/v4
    get:
      tags:
        - List of blockchain entities v2
      summary: List of accounts
      description: >-
        Returns a list of blockchain accounts with their current balance.<br/>
        For rebasing assets, the balances returned are adjusted according to the
        current rebasing conditions.<br/> Results are ordered by tuple
        `(creation_chain_sequence_number, account)`.<br/> To fetch the next page
        of results use `next_page_url` JSON response field.
      operationId: getBlockchainV2ListOfAccounts
      parameters:
        - $ref: '#/components/parameters/BlockchainAsset'
        - $ref: '#/components/parameters/BlockchainAccountsV2'
        - $ref: '#/components/parameters/StartTimeMutuallyExclusiveWithHeightAtlasV2'
        - $ref: '#/components/parameters/EndTimeMutuallyExclusiveWithHeightAtlasV2'
        - $ref: '#/components/parameters/StartHeightMutuallyExclusiveWithTimeAtlasV2'
        - $ref: '#/components/parameters/EndHeightMutuallyExclusiveWithTimeAtlasV2'
        - $ref: '#/components/parameters/BlockchainStartChainSequenceNumberV2'
        - $ref: '#/components/parameters/BlockchainEndChainSequenceNumberV2'
        - $ref: '#/components/parameters/StartInclusiveAtlasV2'
        - $ref: '#/components/parameters/EndInclusiveAtlasV2'
        - $ref: '#/components/parameters/Timezone'
        - $ref: '#/components/parameters/PageSizeAtlasV2'
        - $ref: '#/components/parameters/PagingFrom'
        - $ref: '#/components/parameters/Pretty'
        - $ref: '#/components/parameters/NextPageToken'
        - $ref: '#/components/parameters/IgnoreUnsupportedErrors'
      responses:
        '200':
          $ref: '#/components/responses/BlockchainAccountsV2'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '403':
          $ref: '#/components/responses/BlockchainForbidden'
      security:
        - api_key: []
      x-codeSamples:
        - lang: Shell
          label: Shell
          source: >
            # Gets list of accounts for USDC

            curl --compressed
            "https://api.coinmetrics.io/v4/blockchain-v2/usdc/accounts?pretty=true&api_key=<your_key>"
        - lang: Python
          label: Python
          source: >
            # Gets list of accounts for USDC

            import requests

            response =
            requests.get('https://api.coinmetrics.io/v4/blockchain-v2/usdc/accounts?pretty=true&api_key=<your_key>').json()

            print(response)
        - lang: Python
          label: Python Client
          source: |
            # Gets list of accounts for USDC
            from coinmetrics.api_client import CoinMetricsClient
            client = CoinMetricsClient(<your_key>)

            response = client.get_list_of_blocks_v2(asset="usdc").to_list()
            print(response)
components:
  parameters:
    BlockchainAsset:
      description: Asset name.
      in: path
      name: asset
      required: true
      schema:
        type: string
    BlockchainAccountsV2:
      description: >-
        Optional comma separated list of accounts to filter a response.<br/> The
        list must contain a single element for Community users.
      in: query
      name: accounts
      schema:
        type: array
        items:
          type: string
      explode: false
    StartTimeMutuallyExclusiveWithHeightAtlasV2:
      description: >-
        Start of the time interval.<br/> This field refers to the `time` field
        in the response.<br/> Multiple formats of ISO 8601 are supported:
        `2006-01-20T00:00:00Z`, `2006-01-20T00:00:00.000Z`,
        `2006-01-20T00:00:00.123456Z`, `2006-01-20T00:00:00.123456789Z`,
        `2006-01-20`, `20060120`.<br/> Inclusive by default. Mutually exclusive
        with `start_height`.<br/> UTC timezone by default. `Z` suffix is
        optional and `timezone` parameter has a priority over it.<br/> If
        `start_time` is omitted, response will include time series from the
        **earliest** time available.<br/> This parameter is disabled for
        Community users.
      in: query
      name: start_time
      schema:
        type: string
    EndTimeMutuallyExclusiveWithHeightAtlasV2:
      description: >-
        End of the time interval.<br/> This field refers to the `time` field in
        the response.<br/> Multiple formats of ISO 8601 are supported:
        `2006-01-20T00:00:00Z`, `2006-01-20T00:00:00.000Z`,
        `2006-01-20T00:00:00.123456Z`, `2006-01-20T00:00:00.123456789Z`,
        `2006-01-20`, `20060120`.<br/> Inclusive by default. Mutually exclusive
        with `end_height`.<br/> UTC timezone by default. `Z` suffix is optional
        and `timezone` parameter has a priority over it.<br/> If `end_time` is
        omitted, response will include time series up to the **latest** time
        available.<br/> This parameter is disabled for Community users.
      in: query
      name: end_time
      schema:
        type: string
    StartHeightMutuallyExclusiveWithTimeAtlasV2:
      description: >-
        The start height indicates the beginning block height for the set of
        data that are returned.<br/> Inclusive by default. Mutually exclusive
        with `start_time`.<br/> This parameter is disabled for Community users.
      in: query
      name: start_height
      schema:
        type: integer
        format: int64
        minimum: 0
    EndHeightMutuallyExclusiveWithTimeAtlasV2:
      description: >-
        The end height indicates the ending block height for the set of data
        that are returned.<br/> Inclusive by default. Mutually exclusive with
        `end_time`.<br/> This parameter is disabled for Community users.
      in: query
      name: end_height
      schema:
        type: integer
        format: int64
        minimum: 0
    BlockchainStartChainSequenceNumberV2:
      description: >-
        Start of the `chain_sequence_number` interval.<br/> This parameter is
        disabled for Community users.
      in: query
      name: start_chain_sequence_number
      schema:
        type: integer
        format: int64
        minimum: 0
    BlockchainEndChainSequenceNumberV2:
      description: >-
        End of the `chain_sequence_number` interval.<br/> This parameter is
        disabled for Community users.
      in: query
      name: end_chain_sequence_number
      schema:
        type: integer
        format: int64
        minimum: 0
    StartInclusiveAtlasV2:
      description: >-
        Inclusive or exclusive corresponding `start_*` parameters.<br/> This
        parameter is disabled for Community users.
      in: query
      name: start_inclusive
      schema:
        default: true
        type: boolean
    EndInclusiveAtlasV2:
      description: >-
        Inclusive or exclusive corresponding `end_*` parameters.<br/> This
        parameter is disabled for Community users.
      in: query
      name: end_inclusive
      schema:
        default: true
        type: boolean
    Timezone:
      description: >-
        Timezone name for `start_time` and `end_time` timestamps.<br/> This
        parameter does not modify the output times, which are always `UTC`.<br/>
        Format is defined by [TZ
        database](https://en.wikipedia.org/wiki/List_of_tz_database_time_zones).
      in: query
      name: timezone
      schema:
        example: America/New_York
        default: UTC
        type: string
    PageSizeAtlasV2:
      description: >-
        Number of items per single page of results.<br/> This parameter is
        disabled for Community users.
      in: query
      name: page_size
      schema:
        default: 100
        type: integer
        format: int32
        minimum: 1
        maximum: 10000
    PagingFrom:
      description: >-
        Where does the first page start, at the start of the interval or at the
        end.<br/> The value of this parameter is ignored if the endpoint
        supports the `format` parameter and its value is set to `json_stream`.
      in: query
      name: paging_from
      schema:
        default: end
        enum:
          - start
          - end
        type: string
        format: PagingFrom
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
    NextPageToken:
      description: >-
        Token for receiving the results from the next page of a query.<br/>
        Should not be used directly. To iterate through pages just use
        `next_page_url` response field.
      in: query
      name: next_page_token
      schema:
        type: string
    IgnoreUnsupportedErrors:
      description: >-
        Ignore "unsupported" errors for not currently supported by Coin Metrics
        items.
      in: query
      name: ignore_unsupported_errors
      schema:
        type: boolean
        default: false
  responses:
    BlockchainAccountsV2:
      description: Blockchain accounts.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/BlockchainAccountsResponseV2'
          example:
            data:
              - account: 112jmDkNGHSbhhY17JGpxU3sMA9ZExG7b2
                type: UTXO
                balance: '0.0000583'
                n_debits: '3'
                n_credits: '4'
                creation_height: '470920'
                creation_block_hash: >-
                  0000000000000000002c7505ef2272e0677fa53d68d633f8e076ed42dd3380e6
                creation_time: '2017-06-12T06:50:36.000000000Z'
                creation_chain_sequence_number: '2022585999040108'
                last_chain_sequence_number: '2054987232324222'
                last_debit_height: '474496'
                last_credit_height: '478464'
              - account: 112dtXeVfH3QgRJJwCiQe1FuRAKBqWfY3U
                type: UTXO
                balance: '0'
                n_debits: '6'
                n_credits: '6'
                creation_height: '480777'
                creation_block_hash: >-
                  0000000000000000000e7d28b7c2a37e42278e5d34c8a64a05d227e3608feac8
                creation_time: '2017-08-16T12:34:59.000000000Z'
                creation_chain_sequence_number: '2064921491679245'
                last_chain_sequence_number: '2207213758185607'
                last_debit_height: '513907'
                last_credit_height: '513892'
            next_page_token: >-
              MzA1MDYxMjE5MTE1MDIxNXxiYzFxeDlydnhzZTU2M3NsdTRuM3gzNHFkY3RzYWFxa21wbnNmN240MDM
            next_page_url: >-
              https://api.coinmetrics.io/v4/blockchain-v2/btc/accounts?api_key=<your_key>&pretty=true&page_size=10000&next_page_token=MzA1MDYxMjE5MTE1MDIxNXxiYzFxeDlydnhzZTU2M3NsdTRuM3gzNHFkY3RzYWFxa21wbnNmN240MDM
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    BlockchainForbidden:
      content:
        application/json:
          example:
            error:
              type: forbidden
              message: Requested resource is not available with supplied credentials.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Requested resource is not available with supplied credentials.
  schemas:
    BlockchainAccountsResponseV2:
      description: Blockchain accounts response.
      properties:
        data:
          items:
            type: object
            properties:
              account:
                $ref: '#/components/schemas/BlockchainAccount'
              type:
                $ref: '#/components/schemas/BlockchainAccountType'
              balance:
                $ref: '#/components/schemas/BlockchainAccountBalance'
              n_debits:
                $ref: '#/components/schemas/BlockchainNumberOfDebits'
              n_credits:
                $ref: '#/components/schemas/BlockchainNumberOfCredits'
              creation_height:
                $ref: '#/components/schemas/BlockchainBlockHeight'
              creation_block_hash:
                $ref: '#/components/schemas/BlockchainBlockHash'
              creation_time:
                $ref: '#/components/schemas/Time'
              creation_chain_sequence_number:
                $ref: '#/components/schemas/BlockchainChainSequenceNumber'
              last_chain_sequence_number:
                $ref: '#/components/schemas/BlockchainChainSequenceNumber'
              last_debit_height:
                $ref: '#/components/schemas/BlockchainBlockHeight'
              last_credit_height:
                $ref: '#/components/schemas/BlockchainBlockHeight'
              denomination:
                $ref: '#/components/schemas/BlockchainDenomination'
            required:
              - account
              - type
              - creation_height
              - creation_block_hash
              - creation_time
              - creation_chain_sequence_number
        next_page_token:
          $ref: '#/components/schemas/NextPageToken'
        next_page_url:
          $ref: '#/components/schemas/NextPageUrl'
      required:
        - data
      type: object
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    BlockchainAccount:
      description: Account id.
      type: string
    BlockchainAccountType:
      description: 'Account type. The possible values are: `UTXO`, `VIRTUAL`, `ACCOUNT`.'
      type: string
    BlockchainAccountBalance:
      description: Balance of the account.
      type: string
      format: decimal
    BlockchainNumberOfDebits:
      description: Number of debits.
      type: string
      format: int64
    BlockchainNumberOfCredits:
      description: Number of credits.
      type: string
      format: int64
    BlockchainBlockHeight:
      description: Height of the block.
      type: string
      format: int64
    BlockchainBlockHash:
      description: Hash of the block.
      type: string
    Time:
      description: >-
        The time in ISO 8601 date-time format. Always with nanoseconds
        precision.
      type: string
      format: date-time
    BlockchainChainSequenceNumber:
      description: Chain sequence number.
      type: string
      format: int64
    BlockchainDenomination:
      description: >-
        The denomination of the asset transacted. Only set if not the same as
        the asset being queried.
      type: string
    NextPageToken:
      description: Token of the next page results for a given request.
      type: string
    NextPageUrl:
      description: URL of the next page results for a given request.
      type: string
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````